#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two14004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 1400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two14004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two14004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 1400
# -------------------------------------------------------------------------------------------------
shot2two14004xi = {
        1:'1005x-970y-83z',
        2:'1007x-938y-252z',
        3:'100x-904y-1063z',
        4:'1053x-882y-265z',
        5:'1054x-916y-97z',
        6:'1096x-824y-279z',
        7:'1099x-859y-111z',
        8:'112x-559y-1278z',
        9:'1135x-764y-293z',
        10:'1142x-799y-124z',
        11:'1171x-702y-306z',
        12:'1181x-738y-138z',
        13:'1203x-639y-320z',
        14:'1217x-674y-152z',
        15:'122x-1393y-57z',
        16:'1232x-573y-334z',
        17:'1249x-609y-166z',
        18:'1257x-507y-347z',
        19:'1277x-542y-180z',
        20:'1279x-439y-361z',
        21:'1296x-371y-374z',
        22:'129x-709y-1199z',
        23:'1302x-474y-194z',
        24:'1310x-301y-388z',
        25:'1320x-232y-401z',
        26:'1323x-404y-208z',
        27:'1327x-162y-415z',
        28:'1328x-22y-441z',
        29:'1329x-92y-428z',
        30:'1341x-334y-222z',
        31:'1352x-362y-3z',
        32:'1354x-263y-235z',
        33:'1364x-191y-249z',
        34:'1369x-119y-263z',
        35:'1369x-291y-17z',
        36:'1371x-47y-277z',
        37:'1382x-218y-31z',
        38:'138x-540y-1284z',
        39:'1391x-146y-45z',
        40:'1396x-73y-59z',
        41:'145x-887y-1072z',
        42:'163x-690y-1206z',
        43:'174x-557y-1381z',
        44:'17x-756y-1177z',
        45:'189x-868y-1081z',
        46:'195x-1384y-71z',
        47:'196x-669y-1213z',
        48:'226x-646y-1220z',
        49:'232x-846y-1090z',
        50:'255x-622y-1227z',
        51:'25x-608y-1260z',
        52:'267x-1371y-85z',
        53:'272x-823y-1099z',
        54:'282x-597y-1234z',
        55:'307x-570y-1240z',
        56:'311x-797y-1107z',
        57:'330x-543y-1247z',
        58:'338x-1354y-99z',
        59:'348x-769y-1116z',
        60:'351x-514y-1253z',
        61:'370x-485y-1259z',
        62:'382x-740y-1124z',
        63:'387x-455y-1265z',
        64:'388x-11y-1344z',
        65:'400x-32y-1340z',
        66:'401x-425y-1271z',
        67:'408x-1334y-113z',
        68:'411x-55y-1336z',
        69:'414x-395y-1277z',
        70:'415x-709y-1132z',
        71:'421x-79y-1332z',
        72:'424x-364y-1283z',
        73:'429x-104y-1328z',
        74:'433x-334y-1288z',
        75:'436x-130y-1323z',
        76:'439x-303y-1294z',
        77:'441x-157y-1319z',
        78:'443x-273y-1299z',
        79:'444x-185y-1314z',
        80:'445x-243y-1304z',
        81:'445x-677y-1141z',
        82:'446x-214y-1309z',
        83:'473x-644y-1149z',
        84:'477x-1309y-127z',
        85:'499x-609y-1157z',
        86:'49x-1398y-43z',
        87:'522x-574y-1164z',
        88:'53x-919y-1054z',
        89:'543x-537y-1172z',
        90:'544x-1281y-141z',
        91:'55x-593y-1266z',
        92:'562x-500y-1180z',
        93:'56x-743y-1185z',
        94:'578x-463y-1187z',
        95:'592x-425y-1194z',
        96:'593x-27y-1267z',
        97:'5x-931y-1045z',
        98:'603x-387y-1202z',
        99:'603x-59y-1261z',
        100:'610x-1250y-155z',
        101:'611x-93y-1255z',
        102:'612x-349y-1209z',
        103:'618x-127y-1249z',
        104:'619x-311y-1216z',
        105:'623x-163y-1243z',
        106:'623x-273y-1223z',
        107:'625x-199y-1236z',
        108:'625x-236y-1229z',
        109:'657x-1236y0z',
        110:'674x-1215y-169z',
        111:'721x-1199y-13z',
        112:'736x-1176y-182z',
        113:'782x-1160y-27z',
        114:'795x-1135y-196z',
        115:'842x-1117y-41z',
        116:'852x-1090y-210z',
        117:'85x-577y-1272z',
        118:'899x-1071y-55z',
        119:'907x-1042y-224z',
        120:'93x-727y-1192z',
        121:'953x-1022y-69z',
        122:'958x-991y-238z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1400two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1400two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1400TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1400TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1400TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1400TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1400TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two14004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1400TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1400TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1400TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two14004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two14004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1400TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1400TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1400TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two14004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        